<?php
namespace HCM\SST\Repository;

use Doctrine\DBAL\Connection;
use Doctrine\ORM\EntityManager;

class HistoricoepiRepository {

    protected  $connection;
    public function __construct(Connection $connection, EntityManager $entityManager) {
        $this->connection    = $connection;
        $this->entityManager = $entityManager;
    }

    public function getSimulacaoEntregaEpi($criterio, $inicio, $fim, $inicioPeriodo, $fimPeriodo, $qtTempoMedio, $qtPessoasAtend, $qtHorasAtend, $dtCompetencia, $nrorg) {
        try {
            $query = <<<SQL
SELECT EPI.NMEPI, VIN.NMVINCULOM, PCN.NMPRINCIPALPARC, SIM.*
  FROM SST_EPI EPI, GPE_VINCULOM VIN,
       TABLE (AJUSTA_DATAS_PROG_EPI ('$criterio', '$inicio', '$fim', '$inicioPeriodo', '$fimPeriodo', '$qtTempoMedio', '$qtPessoasAtend', '$qtHorasAtend', '$dtCompetencia', '$nrorg')) SIM
  LEFT JOIN PARCNEGOCIO PCN
    ON (PCN.NRPARCNEGOCIO = SIM.NRPARCNEGOCIO
   AND  PCN.NRORG = SIM.NRORG)
 WHERE EPI.NREPI = SIM.NREPI
   AND EPI.NRORG = SIM.NRORG
   AND VIN.NRVINCULOM = SIM.NRVINCULOM
   AND VIN.NRORG = SIM.NRORG
 ORDER BY SIM.DTENTREGAEPI, VIN.NMVINCULOM, SIM.NREPI
SQL;
            return $this->connection->fetchAll($query);
        } catch (\Exception $e) {
            throw $e;
        }
    }

    public function getDadosGravarHistoricoEpi($criterio, $inicio, $fim, $inicioPeriodo, $fimPeriodo, $qtTempoMedio, $qtPessoasAtend, $qtHorasAtend, $dtCompetencia, $nrorg) {
        try {
            $sql = "SELECT *
                      FROM TABLE (AJUSTA_DATAS_PROG_EPI (:CRITERIO, :INICIO, :FIM, :INIPERIODO, :FIMPERIODO, :QTTEMPOMEDIO, :QTDPESSOASATEND, :QTDHORASATEND, :DTCOMPETENCIA, :NRORG))";

            $params = array(
                'FIM'             => $fim,
                'INICIO'          => $inicio,
                'CRITERIO'        => $criterio,
                'INIPERIODO'      => $inicioPeriodo,
                'FIMPERIODO'      => $fimPeriodo,
                'QTTEMPOMEDIO'    => $qtTempoMedio,
                'QTDPESSOASATEND' => $qtPessoasAtend,
                'QTDHORASATEND'   => $qtHorasAtend,
                'DTCOMPETENCIA'   => $dtCompetencia,
                'NRORG'           => $nrorg
            );

            return $this->connection->fetchAll($sql, $params);
        } catch (\Exception $e) {
            throw $e;
        }
    }

    public function setAssinarAutomaticamente( $nrorg, $nrvinculom, $nrepi, $dtefetiva_ini, $dtefetiva_fim, $idfichaepiassinada, $cdoperultatu ) {
        try {
            $nrvinculom = is_array( $nrvinculom ) ? implode( ',', $nrvinculom ) : $nrvinculom;
            $nrepi      = is_array( $nrepi      ) ? implode( ',', $nrepi      ) : $nrepi;

            $sql = $this->entityManager->getConnection()->prepare( "
                UPDATE sst_historicoepi
                SET idfichaepiassinada = :p_idfichaepiassinada,
                cdoperultatu = :p_cdoperultatu,
                dtultatu = SYSDATE,
                nrorgultatu = :p_nrorg
                WHERE nrorg = :p_nrorg
                AND ( INSTR( ',' || :p_nrvinculom || ',', ',' || nrvinculom || ',' ) > 0 OR :p_nrvinculom IS NULL )
                AND ( INSTR( ',' || :p_nrepi      || ',', ',' || nrepi      || ',' ) > 0 OR :p_nrepi      IS NULL )
                AND dtefetiva BETWEEN TO_DATE( :p_dtefetiva_ini, 'DD/MM/YYYY' ) AND TO_DATE( :p_dtefetiva_fim, 'DD/MM/YYYY' )
            " );
            
            $params = array(
                'p_nrorg'              => $nrorg,
                'p_nrvinculom'         => $nrvinculom,
                'p_nrepi'              => $nrepi,
                'p_dtefetiva_ini'      => $dtefetiva_ini,
                'p_dtefetiva_fim'      => $dtefetiva_fim,
                'p_idfichaepiassinada' => $idfichaepiassinada,
                'p_cdoperultatu'       => $cdoperultatu
            );

            return $sql->execute( $params );
        } catch( \Exception $e ) {
            throw $e;
        }
    }
} 

