<?php
namespace HCM\SST\Repository;

use Doctrine\DBAL\Connection;
use Doctrine\ORM\EntityManager;

class RegistroAmbientalRepository {

    protected  $connection;
    public function __construct(Connection $connection, EntityManager $entityManager) {
        $this->connection    = $connection;
        $this->entityManager = $entityManager;
    }

    public function existeMesmoPeriodoRegistroAmbiental($row) 
    {
        try {
            $sql = $this->entityManager->getConnection()->prepare( 
                "SELECT *
                FROM SST_RESPREGAMB
                WHERE NRESTRUTURAM = :P_NRESTRUTURAM
                  AND NRORG = :P_NRORG
                  AND :P_DTINICIO <= NVL(DTFIMRESAMB, :P_DTINICIO)
                  AND (:P_DTFIM >= DTINIRESAMB OR :P_DTFIM IS NULL)"
                    );
                    
                    $sql->execute(
                        array(
                            'P_NRORG' => $row['NRORG'],
                            'P_DTFIM' =>  $row['DTFIMRESAMB'],
                            'P_NRESTRUTURAM' => $row['NRESTRUTURAM'],
                            'P_DTINICIO' => $row['DTINIRESAMB'],

                        )
                    );
                    
                    return $sql->fetch();  
        } catch (\Exception $e) {
            throw $e;
        }
    }

} 

