-- ============================================================
--   Database name:  FOLHA                                   
--   DBMS name:      ORACLE Version 12.x 
--   Created on:     20/09/2023  12:00                        
--   Issue:          437458 - [HCM] - Alterações referente ao envio do S-1010 para o esocial

-- ============================================================
-- Table: ESO_RUBRICA
-- ============================================================

CREATE TABLE ESO_RUBRICA
(
    NRORG                 NUMBER          NOT NULL,
    NRRUBRICA             NUMBER          NOT NULL,
    NRTIPOMOVIMENT        NUMBER          NULL,
    NRTIPORUBRICA         NUMBER          NULL,
    CDINCIDECP            VARCHAR2(8)     NULL,
    CDINCIDEFGTS          VARCHAR2(8)     NULL,
    CDINCIDEIRRF          VARCHAR2(8)     NULL,
    NREVENTOM             NUMBER          NULL,
    IDATIVO               VARCHAR2(1)     DEFAULT 'S' NOT NULL
    CONSTRAINT CKC_IDATIVO_ESORUBRICA CHECK (IDATIVO IN ('N','S')),
    DTINCLUSAO            DATE            DEFAULT SYSDATE NOT NULL,
    DTULTATU              DATE            NULL,
    NRORGINCLUSAO         NUMBER(22)      DEFAULT 1 NULL,
    CDOPERINCLUSAO        VARCHAR2(12)    DEFAULT '1' NULL,
    NRORGULTATU           NUMBER(22)      DEFAULT 1 NULL,
    CDOPERULTATU          VARCHAR2(12)    DEFAULT '1' NULL,
    CONSTRAINT PK_ESO_NRRUBRICA PRIMARY KEY (NRRUBRICA),
    CONSTRAINT FK_ESO_NRTIPOMOVIMENT FOREIGN KEY (NRTIPOMOVIMENT) REFERENCES FPA_TIPOMOVIMENT (NRTIPOMOVIMENT),
    CONSTRAINT FK_ESO_NREVENTOM_ FOREIGN KEY (NREVENTOM) REFERENCES FPA_EVENTOM (NREVENTOM)  
);
